"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('@angular/core');
var router_1 = require('@angular/router');
var current_tutorial_1 = require('./current-tutorial');
var dynamic_base_module_1 = require('./dynamic-base-module');
var page_title_service_1 = require('./page-title.service');
var TutorialPage = (function () {
    function TutorialPage(route, compiler, viewContainerRef, currentTutorial, seo) {
        this.route = route;
        this.compiler = compiler;
        this.viewContainerRef = viewContainerRef;
        this.currentTutorial = currentTutorial;
        this.seo = seo;
    }
    TutorialPage.prototype.ngOnInit = function () {
        var _this = this;
        this.route.data.subscribe(function (data) {
            var routeData = data;
            _this.tutorial = routeData.tutorialObject;
            _this.step = routeData.stepObject;
            _this.steps = routeData.steps;
            _this.currentTutorial.updateCurrentTutorial(_this.tutorial);
            _this.currentTutorial.updateCurrentStep(_this.step);
            _this.currentTutorial.updateCurrentSteps(_this.steps);
            var htmlContent = data.resolveData.step;
            _this.seo.setSeoDescription(htmlContent);
            _this.seo.addKeywords(_this.step.name.split(' ') || []);
            var DynamicComponent = (function () {
                function DynamicComponent() {
                }
                DynamicComponent = __decorate([
                    core_1.Component({
                        selector: 'tutorial-container',
                        template: htmlContent
                    }), 
                    __metadata('design:paramtypes', [])
                ], DynamicComponent);
                return DynamicComponent;
            }());
            var DynamicModule = (function () {
                function DynamicModule() {
                }
                DynamicModule = __decorate([
                    core_1.NgModule({
                        imports: [dynamic_base_module_1.DummyModule],
                        declarations: [DynamicComponent]
                    }), 
                    __metadata('design:paramtypes', [])
                ], DynamicModule);
                return DynamicModule;
            }());
            var factories = _this.compiler.compileModuleAndAllComponentsSync(DynamicModule);
            var compFactory = factories.componentFactories.find(function (x) { return x.componentType === DynamicComponent; });
            var injector = core_1.ReflectiveInjector.fromResolvedProviders([], _this.viewContainerRef.parentInjector);
            _this.viewContainerRef.createComponent(compFactory, 0, injector, []);
        });
    };
    TutorialPage = __decorate([
        core_1.Injectable(),
        core_1.Component({
            selector: 'tutorial-page',
            template: "<div class='tutorial-container'></div>"
        }), 
        __metadata('design:paramtypes', [router_1.ActivatedRoute, core_1.Compiler, core_1.ViewContainerRef, current_tutorial_1.ActivatedTutorial, page_title_service_1.PageTitleService])
    ], TutorialPage);
    return TutorialPage;
}());
exports.TutorialPage = TutorialPage;
//# sourceMappingURL=tutorial-page.component.js.map